Leader Question -- not what i expect from different perspectives


#1

this is new to me and i haven’t figured out a way (if any) to solve it.

here’s the view from the right:


then the left:


i would expect that either all of the text in the left view is oriented properly to the view -or- all of it would be mirrored… but it’s mixing both together?

here’s the file:

leaderQ.3dm (85.1 KB)

any settings / ideas/ insight / etc ?
thanks.


add- if i select all and orient at different angles/ positions/etc throughout the modelspace, then navigate in perspective view, i can tell that there are some rules in place as to which way to show the text (the individual ‘test’ lines will flip as the camera rotates) … so i guess my question is more along these lines:

if someone knows what the rules regarding text display are, can you please share them? i’d rather not trial&error figure this one out :smile:


(Lowell Walmsley) #2

The view direction is supposed to respond to the view "up and “right” directions.
The text is supposed to orient to have the top more up and to the left in any view, and to appear to be viewed from the “front”.

I’m having trouble reproducing what you have in your file.
I’ve tried drawing leaders in various views and rotating leaders around various axis and not so far been able to make them read backwards like what you have.

What did you do to make the leaders in your example?

Lowell


(Pascal Golay) #3

I’m not able, so far, to make leaders do this either.

-Pascal


#4

hey lowell. thanks for looking at it.

they were created in a python script… it’s sort of long and you might have to wade through a bunch of stuff to pinpoint where the leaders are added… i’ll see if i can make a condensed script which showcases only the leader making parts…


Leader text is randomly inverting when panning/rotating view. Bug?
(Lowell Walmsley) #5

That would be great Jeff.
Thanks


#6

here’s the basics (my script doesn’t work this way to obtain the start/end points for the leader but this seemed like a simple enough method to showcase the problem)

import rhinoscriptsyntax as rs

line = rs.AddLine((0,0,0),(0,0,-16))
cpt = rs.coerce3dpoint([0,0,96])
vec = rs.coerce3dvector([1,0,0])
l_plane = rs.WorldYZPlane()

for i in range (1,13):
    rline= rs.RotateObject(line, cpt, i*7.5, vec, True )
    start= rs.CurveStartPoint(rline)
    end= rs.CurveEndPoint(rline)
    rs.AddLeader((start,end,end), l_plane, 'Test')

of note- my script also contains the rs.WorldYZPlane() part so maybe that’s where the problem lies?

of note part2- you’ll notice there is a duplicate point being used in rs.AddLeader.

that’s because of this:

discourse.mcneel.com/t/rs-addleader-needs-more-than-two-points/15768


i just assumed the text was showing wrong due to something with the text itself instead of how it was added to the model… but if you can’t point out what’s causing the behavior when placed with the above script, that’d be great.
thanks


(Lowell Walmsley) #7

OK, I haven’t had time to completely dig into this, but it looks like there’s a bug in the way the text flips in the lower-left quadrant looking from the back.

I’ll figure it out soon. I have to dig out of a couple of other things right now.

Thanks for the report


#8

thanks lowell.
no rush.


(Lowell Walmsley) #9

Jeff,
I believe that works correctly now.
I fixed it in Windows code and I’m not sure how long it takes for that to trickle through to Mac. Probably at least a couple of weeks.

Also, the thing about needing 3 points in AddLeader() appears to be fixed in a recent Mac build.

Thanks,
Lowell


#10

great! thanks so much.